Index: trunk/doc/cookbook.tex
===================================================================
--- trunk/doc/cookbook.tex	(revision 794)
+++ trunk/doc/cookbook.tex	(revision 953)
@@ -39,7 +39,7 @@
 package.
 
-%\section{Documentation Standards}
-
-%In most of the examples in this document, it has been assumed that the
+This useeguide is currently being updated for the ASAP 2.0 release
+which has a number of significant changes which affect the user
+interface. Please report any mistakes you find in this userguide.
 
 \section{Installation and Running}
@@ -58,5 +58,5 @@
 \begin{verbatim}
   > cd /my/data/directory
-  > asap
+  > asap2
 \end{verbatim}
 
@@ -88,6 +88,8 @@
   \item[\cmd{scantable}] The data container (actual spectra and header
     information)
+  \item[\cmd{selector}] Allows the user to select a subsection of the
+    data, such as a specified or ramge of beam numbers, IFs, etc.
+  \item[\cmd{plotter}] A tool used to plot the spectral line data
   \item[\cmd{fitter}] A tool used to fit functions to the spectral data
-  \item[\cmd{plotter}] A tool used to plot the spectral line data
   \item[\cmd{reader}] A tool which can be used to read data from disks
     into a scantable object.
@@ -121,7 +123,7 @@
 
 \begin{verbatim}
-  ASAP> av = scans(msk,weight='tsys')
-  ASAP> av = scans(mask=msk,weight='tsys')
-  ASAP> av = scans(msk,tsys)
+  ASAP> av = scans.average_time(msk,weight='tsys')
+  ASAP> av = scans.average_time(mask=msk,weight='tsys')
+  ASAP> av = scans.average_time(msk,tsys)
   ASAP> scans.polybaseline(mask=msk, order=0, insitu=True)
   ASAP> scans.polybaseline(msk,0,True)
@@ -190,4 +192,5 @@
   ASAP> pwd
   ASAP> ls
+  ASAP> cd /my/data/directory
   ASAP> ! mozilla&
 \end{verbatim}
@@ -241,9 +244,9 @@
 
   # default output format when saving scantable
-  scantable.save             : 'ASAP'
+  scantable.save             : ASAP
 
   # default frequency frame to set when function
   # scantable.set_freqframe is called
-  scantable.freqframe        : 'LSRK'
+  scantable.freqframe        : LSRK
 
   # auto averaging on read
@@ -251,5 +254,5 @@
 \end{verbatim}
 
-For a complete list of \cmd{.asaprc} values, see the appendix.
+For a complete list of \cmd{.asaprc} values, see the Appendix.
 
 \section{Scantables}
@@ -262,4 +265,6 @@
 scantables.  A scantable holds your data, and also provides functions
 to operate upon it.
+
+{\bf [MALTE: Could you please reword this??]}
 
 The building block of a scantable is an integration, which is a single
@@ -284,11 +289,13 @@
 
 \index{Scantable!contents}A scantable has header information and data
-(a scantable is actually an AIPS++ Table and it is stored in Memory
-when you are manipulating it with ASAP.  You can store it to disk and
-then browse it with the AIPS++ Table browser if you know how to do
-that !).
+(a scantable is actually an AIPS++ Table and it is generally stored in
+memory when you are manipulating it with ASAP.  You can save it to
+disk and then browse it with the AIPS++ Table browser if you know how
+to do that !).
 
 The data are stored in columns (the length of a column is the number of
 rows/integrations of course).
+
+{\bf [MALTE: Is this outdated??]}
 
 Two important columns are those that describe the frequency setup.  We mention
@@ -304,22 +311,4 @@
 the flags, the Tsys, the source names and so on, but those are a little
 more transparently handled.
-
-\subsection{Management}
-
-\index{Scantable!management}During processing it is possible to create
-a large number of scan tables. These all consume memory, so it is best
-to periodically remove unneeded scan tables. Use \cmd{list\_scans} to
-print a list of all scantables and \cmd{del} to remove unneeded ones.
-
-Example:
-
-\begin{verbatim}
-  ASAP> list_scans()
-  The user created scantables are:
-  ['s', 'scans', 'av', 's2', 'ss']
-
-  ASAP> del s2
-  ASAP> del ss
-\end{verbatim}
 
 There is also a function \cmd{summary} to list a summary of the scantable.
@@ -349,4 +338,9 @@
 refer, is always listed.
 
+\subsection{Data Selection}
+\label{sec:selection}
+
+CHRIS TOFILL IN
+
 %You can copy one scantable to another with the \cmd{copy} function.
 
@@ -404,5 +398,6 @@
 from the RPFITS file when reading the data. The values stored in the
 RPFITS file are not always correct and so there is a function
-\cmd{set\_restfreq} to set the rest frequencies.
+\cmd{set\_restfreq} to set the rest frequencies for the currently
+selected data.
 
 For each integration, there is a rest-frequency per IF (the rest
@@ -410,22 +405,15 @@
 There are a few ways to set the rest frequencies with this function.
 
-If you specify just one rest frequency, then it is selected for the
-specified source and IF and added to the list of rest frequencies.
-
-\begin{verbatim}
-  # Select for specified source/IF
-  ASAP> scans.set_restfreqs(freqs=1.667359e9, source='NGC253', theif=0)
-
-  # Select for all sources and IFs
+If you specify just one rest frequency, then it is set for all IF.
+
+\begin{verbatim}
+  # Set all IFs
   ASAP> scans.set_restfreqs(freqs=1.667359e9)
 \end{verbatim}
 
-
-If you specify a list of frequencies, then it must be of length the
-number of IFs.  Regardless of the source, the rest frequency will be set
-for each IF to the corresponding value in the provided list.  The
-internally stored list of rest frequencies will be replaced by this
-list.
-
+If set a rest frequency for each IF, specify a list of frequencies (of
+length the number of IFs).  Regardless of the source, the rest
+frequency will be set for each IF to the corresponding value in the
+provided list. 
 
 \begin{verbatim}
@@ -435,4 +423,6 @@
 \end{verbatim}
 
+{\em Currently this is not implemented}
+
 In both of the above modes, you can also specify the rest frequencies via
 names in a known list rather than by their values.
@@ -441,45 +431,7 @@
 
 \begin{verbatim}
-  ASAP> scans.lines()                 # Print list of known lines
-  ASAP> scans.set_restfreqs(lines=['OH1665','OH1667'])
-\end{verbatim}
-
-
-\subsection{Data Selection}
-
-\index{Scantable!data selection}Data selection is currently fairly limited. This
-will be improved in the future.
-
-
-\subsubsection{Cursor}
-
-\index{Scantable!cursor}Generally the user will want to run functions
-on all rows in a scantable. This allows very fast reduction of
-data. There are situations when functions should only operate on
-specific elements of the spectra. This is handled by the scantable
-cursor, which allows the user to select a single beam, IF and
-polarisation combination.
-
-Example :
-
-\begin{verbatim}
-  ASAP> scans.set_cursor(0,2,1)      # beam, IF, pol
-  ASAP> scans.smooth(allaxes=F)      # in situ by default or .aipsrc
-\end{verbatim}
-
-\subsubsection{Row number}
-
-\index{Scantable!row selection}Most functions work on all rows of a
-scan table. Exceptions are the fitter and plotter. If you wish to only
-operate on a selected set of scantable rows, use the \cmd{get\_scan}
-function to copy the rows into a new scantable.
-
-\subsubsection{Allaxes}
-
-\index{allaxes}\index{Scantable!allaxes}Many functions have an
-\cmd{allaxes} option which controls whether the function will operate
-on all elements within a scantable row, or just those selected with
-the current cursor. The default is taken from the users {\tt .asaprc}
-file.
+  ASAP> scans.set_restfreqs(freqs=['OH1665','OH1667'])
+\end{verbatim}
+
 
 \subsubsection{Masks}
@@ -547,4 +499,22 @@
 
 
+\subsection{Management}
+
+\index{Scantable!management}During processing it is possible to create
+a large number of scan tables. These all consume memory, so it is best
+to periodically remove unneeded scan tables. Use \cmd{list\_scans} to
+print a list of all scantables and \cmd{del} to remove unneeded ones.
+
+Example:
+
+\begin{verbatim}
+  ASAP> list_scans()
+  The user created scantables are:
+  ['s', 'scans', 'av', 's2', 'ss']
+
+  ASAP> del s2
+  ASAP> del ss
+\end{verbatim}
+
 \section{Data Input}
 
@@ -576,11 +546,11 @@
 \index{Reader object}\index{Scantable!reader object}For more control
 when reading data into ASAP, the reader object should be used.  This
-has the option of only reading in a range of integrations and does not
-perform any scan averaging of the data, allowing analysis of the
-individual integrations.  Note that due to limitation of the RPFITS
-library, only one reader object can be open at one time reading RPFITS
-files.  To read multiple RPFITS files, the old reader must be
-destroyed before the new file is opened.  However, multiple readers
-can be created and attached to SDFITS files.
+has the option of only reading in a range of integrations, only a
+specified beam or IF and does not perform any scan averaging of the
+data, allowing analysis of the individual integrations.  Note that due
+to limitation of the RPFITS library, only one reader object can be
+open at one time reading RPFITS files.  To read multiple RPFITS files,
+the old reader must be destroyed before the new file is opened.
+However, multiple readers can be created and attached to SDFITS files.
 
 
@@ -602,7 +572,4 @@
 default value from \cmd{True}.
 
-%\subsection{Editing}
-
-%How and when?
 \subsection{Auto quotient}
 \index{Auto quotient}Quotients can be computed ``automatically''. This
@@ -616,44 +583,44 @@
 \end{verbatim}
 
-If this is not sufficient the following alternative method can be used.
-
-\subsection{Separate reference and source observations}
-
-\index{Quotient spectra}Most data from ATNF observatories
-distinguishes on and off source data using the file name. This makes
-it easy to create two scantables with the source and reference
-data. As long as there was exactly one reference observation for each
-on source observation for following method will work.
-
-For Mopra and Parkes data:
-\begin{verbatim}
-  ASAP> r = scans.get_scan('*_R')
-  ASAP> s = scans.get_scan('*_S')
-\end{verbatim}
-
-For Tidbinbilla data
-\begin{verbatim}
-  ASAP> r = scans.get_scan('*_[ew]')
-  ASAP> s = scans.get_scan('*_[^ew]')
-\end{verbatim}
-
-\subsection{Make the quotient spectra}
-
-Use the quotient function
-
-\begin{verbatim}
-  ASAP> q = s.quotient(r)
-\end{verbatim}
-
-This uses the rows in scantable \cmd{r} as reference spectra for the
-rows in scantable \cmd{s}. Scantable \cmd{r} must have either 1 row
-(which is applied to all rows in \cmd{s}) or both scantables must have
-the same number of rows. By default the quotient spectra is calculated
-to preserve continuum emission. If you wish to remove the continuum
-contribution, use the \cmd{preserve} argument:
-
-\begin{verbatim}
-  ASAP> q = s.quotient(r, preserve=True)
-\end{verbatim}
+%If this is not sufficient the following alternative method can be used.
+%
+%\subsection{Separate reference and source observations}
+%
+%\index{Quotient spectra}Most data from ATNF observatories
+%distinguishes on and off source data using the file name. This makes
+%it easy to create two scantables with the source and reference
+%data. As long as there was exactly one reference observation for each
+%on source observation for following method will work.
+%
+%For Mopra and Parkes data:
+%\begin{verbatim}
+%  ASAP> r = scans.get_scan('*_R')
+%  ASAP> s = scans.get_scan('*_S')
+%\end{verbatim}
+%
+%For Tidbinbilla data
+%\begin{verbatim}
+%  ASAP> r = scans.get_scan('*_[ew]')
+%  ASAP> s = scans.get_scan('*_[^ew]')
+%\end{verbatim}
+%
+%\subsection{Make the quotient spectra}
+%
+%Use the quotient function
+%
+%\begin{verbatim}
+%  ASAP> q = s.quotient(r)
+%\end{verbatim}
+%
+%This uses the rows in scantable \cmd{r} as reference spectra for the
+%rows in scantable \cmd{s}. Scantable \cmd{r} must have either 1 row
+%(which is applied to all rows in \cmd{s}) or both scantables must have
+%the same number of rows. By default the quotient spectra is calculated
+%to preserve continuum emission. If you wish to remove the continuum
+%contribution, use the \cmd{preserve} argument:
+%
+%\begin{verbatim}
+%  ASAP> q = s.quotient(r, preserve=True)
+%\end{verbatim}
 
 \subsection{Time average separate scans}
@@ -664,5 +631,5 @@
 
 \begin{verbatim}
- ASAP> av = average_time(q)
+ ASAP> av = q.average_time()
 \end{verbatim}
 
@@ -689,7 +656,15 @@
 \end{verbatim}
 
-Note that, if needed, you should run \cmd{freq\_align}, \cmd{gain\_el}
-and \cmd{opacity} before you average the data in time (\S
-\ref{sec:gainel} \& \ref{sec:freqalign}).
+If you have not observed your data with Doppler tracking (or run
+\cmd{freq\_align} explicitally) you should align the data in frequency
+before averaging.
+
+\begin{verbatim}
+ ASAP> av = scans.average_time(align=True)
+\end{verbatim}
+
+Note that, if needed, you should run \cmd{gain\_el} and \cmd{opacity}
+before you average the data in time (\S \ref{sec:gainel} \&
+\ref{sec:freqalign}).
 
 \subsection{Baseline fitting}
@@ -863,17 +838,5 @@
 \end{verbatim}
 
-\cmd{freq\_align} has two modes of operations controlled by the
-\cmd{perif} argument. By default it will align each source and freqid
-separately. This is needed for scan tables containing multiple
-sources. However if scan-based Doppler tracking has been made at the
-observatory, each row will have a different freqid. In these cases run
-with \cmd{perif=True} and all rows of a source will be aligned to the
-same frame. In general \cmd{perif=True} will be needed for most
-observations as Doppler tracking of some form is made at Parkes, Tid
-and Mopra.
-
-\begin{verbatim}
-  ASAP> scans.freq_align(perif=True)
-\end{verbatim}
+{\em A Global freq\_align command will be made eventually}
 
 To average together data taken on different days, which are in
@@ -897,5 +860,7 @@
 new scantable with a selection of scans from a scantable. The
 selection can either be on the source name, with simple wildcard
-matching or set of scan ids.
+matching or set of scan ids. Internally this uses the selector object,
+so for more complicated selection the selector should be used directly
+instead.
 
 For example:
@@ -912,6 +877,6 @@
   ASAP> r = scans.get_scan('*_R') # Get all reference sources (Parkes/Mopra)
   ASAP> s = scans.get_scan('*_S') # Get all program sources (Parkes/Mopra)
-  ASAP> r = scans.get_scan('*_[ew]')  # Get all reference sources (Tid)
-  ASAP> s = scans.get_scan('*_[^ew]') # Get all program sources (Tid)
+  ASAP> r = scans.get_scan('*[ew]')  # Get all reference sources (Tid)
+  ASAP> s = scans.get_scan('*[^ew]') # Get all program sources (Tid)
 
 \end{verbatim}
@@ -936,4 +901,6 @@
 variety of formats, suitable for reading into other packages. The
 formats are:
+
+{\em Currently only raw ASAP output is available. Other formats will be added soon}
 
 \begin{itemize}
@@ -1022,29 +989,30 @@
 stacked spectra per panel. If you have data larger than this (or for
 your own sanity) you need to select a subset of this data. This is
-particularly true for multibeam or multi IF data. The plotter
-\cmd{set\_cursor} function is used to select a subset of the data. The
-arguments \cmd{row}, \cmd{beam} and \cmd{IF} all accept a vector of
-indices corresponding to row, beam or IF selection. Only the selected
-data will be plotted.  To select on polarisation, see
-section~\ref{sec:polplot}.
+particularly true for multibeam or multi IF data. The selector object
+should be used for this purpose. Selection can either be applide to
+the scantable or directly to the plotter, the end result is the same.
 
 Examples:
 
 \begin{verbatim}
+  ASAP> selection = selector()
   # Select second IF
-  ASAP> plotter.set_cursor(IF=[1])
+  ASAP> selection.set_if(1)
+  ASAP> plotter.set_selection(selection)
 
   # Select first 4 beams
-  ASAP> plotter.set_cursor(beam=[0,1,2,3])
-
-  # Select a few rows
-  ASAP> plotter.set_cursor(row=[2,4,6,10])
+  ASAP> selection.set_beam([0,1,2,3])
+  ASAP> plotter.set_selection(selection)
+
+  # Select a few scans
+  ASAP> selection.set_scans([2,4,6,10])
+  ASAP> plotter.set_selection(selection)
 
   # Multiple selection
-  ASAP> plotter.set_cursor(IF=[1], beam=[0,2], row=range(10))
-\end{verbatim}
-
-Note that the plotter cursor selection is independent of the scantable
-cursor.
+  ASAP> selection.set_if(1)
+  ASAP> selection.set_scans([2,4,6,10])
+  ASAP> plotter.set_selection(selection)
+
+\end{verbatim}
 
 \subsection{Plot Control}
@@ -1065,10 +1033,13 @@
 
 \item[Pan] (The Cross) This sets the cursor to pan, or scroll mode
-       allowing you to shift the plot within the window. Useful when
-       zoomed in on a feature.
+  allowing you to shift the plot within the window. Useful when
+  zoomed in on a feature.
 
 \item[Zoom] (the letter with the magnifying glass) lets you draw a
-       rectangle around a region of interest then zooms in on that
-       region. Use the plot history to unzoom again.
+  rectangle around a region of interest then zooms in on that
+  region. Use the plot history to unzoom again.
+
+\item[Adjust] (rectangle with 4 arrows) adjust subplot paramaters
+  (space at edge of plots)
 
 \item[Save] (floppy disk). Save the plot as a postscript or .png file
@@ -1209,10 +1180,4 @@
 \subsection{Simple Calibration}
 
-{\em Currently the receiver position angle is not read from the RPFITS
-file and a position angle of zero is assumed. This severely hampers
-correct handling of polarimetry. In the future we aim to define a
-general framework and populate the RPFITS files with the data required
-for transparent polarimetric calibration.}
-
 \index{Polarisation!calibration}It is possible that there is a phase
 offset between polarisation which will effect the phase of the cross
@@ -1230,14 +1195,28 @@
 
 A correction for the receiver parallactic angle may need to be made,
-either because of how it is mounted or if parallactifiying had to track
-at 90 degrees rather than 0. Use \cmd{rotate\_linpolphase} to correct
-the position angle. Running this function twice results in the sum of
-the corrections being applied because it is applied in-situ.
-
-\begin{verbatim}
-  ASAP> scans.rotate_linpolphase(-20) # Degrees; correct for receiver mounting
-
-  # Receiver was tracking 90 degrees rather than 0
-  ASAP> scans.rotate_linpolphase(90)
+generally because of how it is mounted. Use \cmd{rotate\_linpolphase}
+to correct the position angle. Running this function twice results in
+the sum of the corrections being applied because it is applied
+in-situ.
+
+\begin{verbatim}
+  ASAP> scans.rotate_linpolphase(-45) # Degrees; correct for receiver mounting
+\end{verbatim}
+
+If the sign of the complex correlation is wrong (this can happen
+depending on the correlator configuration), use \cmd{invert\_phase} to
+change take the complex conjugate of the complex correlation
+term. This is always performed in-situ.
+
+\begin{verbatim}
+  ASAP> scans.invert_phase()
+\end{verbatim}
+
+Depending on how the correlator is configured, ``BA'' may be
+correlated insead of ``AB''. Use \cmd{swap\_linears} to correct for
+this problem:
+
+\begin{verbatim}
+  ASAP> scans.swap_linears() 
 \end{verbatim}
 
@@ -1245,8 +1224,10 @@
 \label{sec:polplot}
 
-\index{Polarisation!plotting}To plot Stokes values, the plotter
-\cmd{set\_cursor} function should be called first using the \cmd{pol}
-argument. The values which can be plotted include a selection of
-[I,Q,U,V], [I, Plinear, Pangle, V], [RR, LL] or [XX, YY, Real(XY),
+\index{Polarisation!plotting}To plot Stokes values, a selector object
+must be created and the set\_polarisation function used to select the
+desired polarisation products.
+
+The values which can be plotted include a selection of [I,Q,U,V], [I,
+Plinear, Pangle, V], [RR, LL] or [XX, YY, Real(XY),
 Imaginary(XY)]. (Plinear and Pangle are the percentage and position
 angle of linear polarisation). Conversion to circular polarisations
@@ -1256,12 +1237,25 @@
 
 \begin{verbatim}
-  ASAP> plotter.set_cursor(pol=``I Q'')
-  ASAP> plotter.set_cursor(pol=``RR LL'')
-  ASAP> plotter.set_cursor(pol=``XX YY'')
-  ASAP> plotter.set_cursor(pol=``I Plinear'')
-\end{verbatim}
-
-Row, beam and IF selection are also available in \cmd{set\_cursor} as
-describe in section~\ref{sec:plotter_cursor}.
+  ASAP> selection = selector()
+  
+  ASAP> selection.set_polarisations([``I'', ``Q'', ``U'', ``V'']) 
+  ASAP  plotter.set_selection(selection);              # Select I, Q, U \& V
+
+  ASAP> selection.set_polarisations([``I'', ``Q'') 
+  ASAP  plotter.set_selection(selection);              # Select just I \& Q
+
+  ASAP> selection.set_polarisations([``RR'', ``LL'') 
+  ASAP  plotter.set_selection(selection);              # Select just RR \& LL
+
+  ASAP> selection.set_polarisations([``XX'', ``YY'') 
+  ASAP  plotter.set_selection(selection);              # Select linears
+
+  ASAP> selection.set_polarisations([``I'', ``Plinear'') 
+  ASAP  plotter.set_selection(selection);              # Select linears
+
+\end{verbatim}
+
+Scan, beam and IF selection are also available in the selector object as 
+describe in section~\ref{sec:selection}.
 
 \subsection{Saving}
@@ -1303,4 +1297,5 @@
 
 \hspace{1cm} http://www.atnf.csiro.au/computing/software/asap/tutorials
+
 \hspace{1cm} http://www.python.org/doc/Introduction.html
 
@@ -1528,5 +1523,4 @@
 plotter.plot(a1,a2)
 plotter.set_mode('i','s')
-x = raw_input()
 
 a1.auto_poly_baseline()
@@ -1690,4 +1684,55 @@
 \end{verbatim}
 
+\subsection{ASCII output format}
+
+\subsection{.asaprc settings}
+\index{.asaprc}
+\asaprc{verbose}{{\bf True}/False}{Print verbose output}
+
+\asaprc{insitu}{{\bf True}/False}{Apply operations on the input
+scantable or return new one}
+
+% plotting
+
+\asaprc{useplotter}{{\bf True}/False}{Preload a default plotter}
+
+\asaprc{plotter.gui}{{\bf True}/False}{Do we want a GUI or plot to a
+file}
+
+\asaprc{plotter.stacking}{{\bf Pol} Beam IF Scan Time}{Default mode for
+colour stacking}
+
+\asaprc{plotter.panelling}{Pol Beam IF {\bf Scan} Time}{Default mode
+for panelling}
+
+\asaprc{plotter.ganged}{{\bf True}/False}{Push panels together, to
+share axislabels}
+
+\asaprc{plotter.decimate}{True/{\bf False}}{Decimate the number of
+points plotted by a factor of nchan/1024}
+
+% default colours/linestyles
+%\asaprc{plotter.colours}{.}{.}
+%\asaprc{plotter.linestyles{.}{.}
+
+% scantable
+\asaprc{scantable.save}{{\bf ASAP} SDFITS FITS ASCII MS2}{Default output
+format when saving}
+
+\asaprc{scantable.autoaverage}{{\bf True}/False}{Auto averaging on
+read}
+
+\asaprc{scantable.freqframe}{{\bf LSRK} TOPO BARY etc}{default
+frequency frame to set when function scantable.set\_freqframe is
+called}
+
+\asaprc{scantable.allaxes}{{\bf True}/False}{Apply action to all axes
+not just the cursor location}
+
+\asaprc{scantable.plotter}{{\bf True}/False}{Use internal plotter}
+
+\asaprc{scantable.verbosesummary}{True/{\bf False}}{Control the level
+of information printed by summary}
+
 \subsection{Installation}
 
@@ -1707,55 +1752,4 @@
 Of the dependencies, AIPS++ is the most complex to install.
 
-\subsection{ASCII output format}
-
-\subsection{.asaprc settings}
-\index{.asaprc}
-\asaprc{verbose}{{\bf True}/False}{Print verbose output}
-
-\asaprc{insitu}{{\bf True}/False}{Apply operations on the input
-scantable or return new one}
-
-% plotting
-
-\asaprc{useplotter}{{\bf True}/False}{Preload a default plotter}
-
-\asaprc{plotter.gui}{{\bf True}/False}{Do we want a GUI or plot to a
-file}
-
-\asaprc{plotter.stacking}{{\bf Pol} Beam IF Scan Time}{Default mode for
-colour stacking}
-
-\asaprc{plotter.panelling}{Pol Beam IF {\bf Scan} Time}{Default mode
-for panelling}
-
-\asaprc{plotter.ganged}{{\bf True}/False}{Push panels together, to
-share axislabels}
-
-\asaprc{plotter.decimate}{True/{\bf False}}{Decimate the number of
-points plotted by a factor of nchan/1024}
-
-% default colours/linestyles
-%\asaprc{plotter.colours}{.}{.}
-%\asaprc{plotter.linestyles{.}{.}
-
-% scantable
-\asaprc{scantable.save}{{\bf ASAP} SDFITS FITS ASCII MS2}{Default output
-format when saving}
-
-\asaprc{scantable.autoaverage}{{\bf True}/False}{Auto averaging on
-read}
-
-\asaprc{scantable.freqframe}{{\bf LSRK} TOPO BARY etc}{default
-frequency frame to set when function scantable.set\_freqframe is
-called}
-
-\asaprc{scantable.allaxes}{{\bf True}/False}{Apply action to all axes
-not just the cursor location}
-
-\asaprc{scantable.plotter}{{\bf True}/False}{Use internal plotter}
-
-\asaprc{scantable.verbosesummary}{True/{\bf False}}{Control the level
-of information printed by summary}
-
 \printindex
 