Index: tags/Release2.1.0b/web/commands.html
===================================================================
--- tags/Release2.1.0b/web/commands.html	(revision 1250)
+++ tags/Release2.1.0b/web/commands.html	(revision 1251)
@@ -39,8 +39,7 @@
 ?>
 <!-- Start Content -->
-<h1><a href="index.html">ASAP</a> 'commands'</h1>
+<h1>ASAP 'commands'</h1>
 <pre class="commands">
 ASAP> commands()
-
     [The scan container]
         scantable           - a container for integrations/scans
@@ -49,4 +48,6 @@
             get_scan        - gets a specific scan out of a scantable
                               (by name or number)
+            drop_scan       - drops a specific scan out of a scantable
+                              (by number)
             set_selection   - set a new subselection of the data
             get_selection   - get the current selection object
@@ -67,4 +68,6 @@
             get_abcissa     - get the abcissa values and name for a given
                               row (time)
+            get_column_names - get the names of the columns in the scantable
+                               for use with selector.set_query
             set_freqframe   - set the frame info for the Spectral Axis
                               (e.g. 'LSRK')
@@ -72,4 +75,5 @@
             set_dirframe    - set the frame for the direction on the sky
             set_instrument  - set the instrument name
+            set_feedtype    - set the feed type
             get_fluxunit    - get the brightness flux unit
             set_fluxunit    - set the brightness flux unit
@@ -80,6 +84,7 @@
             set_restfreqs   - set a list of rest frequencies
             flag            - flag selected channels in the data
-            save            - save the scantable to disk as either 'ASAP'
-                              or 'SDFITS'
+            lag_flag        - flag specified frequency in the data
+            save            - save the scantable to disk as either 'ASAP',
+                              'SDFITS' or 'ASCII'
             nbeam,nif,nchan,npol - the number of beams/IFs/Pols/Chans
             nscan           - the number of scans in the scantable
@@ -90,11 +95,10 @@
                               or a list of scans
             average_pol     - average the polarisations together.
-                              The dimension won't be reduced and
-                              all polarisations will contain the
-                              averaged spectrum.
+            average_beam    - average the beams together.
             convert_pol     - convert to a different polarisation type
             auto_quotient   - return the on/off quotient with
-                              automatic detection of the on/off scans
-                              (matched pairs and 1 off - n on)
+                              automatic detection of the on/off scans (closest
+                              in time off is selected)
+            mx_quotient     - Form a quotient using MX data (off beams)
             scale, *, /     - return a scan scaled by a given factor
             add, +, -       - return a scan with given value added
@@ -131,4 +135,5 @@
             set_names          - set a selection by name (wildcards allowed)
             set_tsys           - set a selection by tsys thresholds
+            set_query          - set a selection by SQL-like query, e.g. BEAMNO==1
             reset              - unset all selections
             +                  - merge to selections
@@ -141,4 +146,20 @@
             simple_math     - simple mathematical operations on two scantables,
                               'add', 'sub', 'mul', 'div'
+            quotient        - build quotient of the given on and off scans
+                              (matched pairs and 1 off/n on are valid)
+            merge           - merge a list of scantables
+
+     [Line Catalog]
+        linecatalog              - a linecatalog wrapper, taking an ASCII or
+                                   internal format table
+            summary              - print a summary of the current selection
+            set_name             - select a subset by name pattern, e.g. '*OH*'
+            set_strength_limits  - select a subset by line strength limits
+            set_frequency_limits - select a subset by frequency limits
+            reset                - unset all selections
+            save                 - save the current subset to a table (internal
+                                   format)
+            get_row              - get the name and frequency from a specific
+                                   row in the table
      [Fitting]
         fitter
@@ -163,4 +184,5 @@
                               called 'plotter'
             plot            - plot a scantable
+            plot_lines      - plot a linecatalog overlay
             save            - save the plot to a file ('png' ,'ps' or 'eps')
             set_mode        - set the state of the plotter, i.e.
@@ -177,6 +199,15 @@
             set_linestyles  - specify a set of linestyles to use if only
                               using one color
-            set_histrogra,  - plot in historam style
+            set_font        - set general font properties, e.g. 'family'
+            set_histogram   - plot in historam style
             set_mask        - set a plotting mask for a specific polarization
+            text            - draw text annotations either in data or relative
+                              coordinates
+            arrow           - draw arrow annotations either in data or relative
+                              coordinates
+            axhline,axvline - draw horizontal/vertical lines
+            axhspan,axvspan - draw horizontal/vertical regions
+
+        xyplotter           - matplotlib/pylab plotting functions
 
     [Reading files]
@@ -199,4 +230,5 @@
         list_rcparameters   - print out a list of possible values to be
                               put into $HOME/.asaprc
+        rc                  - set rc parameters from within asap
         mask_and,mask_or,
         mask_not            - boolean operations on masks created with
Index: tags/Release2.1.0b/web/index.html
===================================================================
--- tags/Release2.1.0b/web/index.html	(revision 1250)
+++ tags/Release2.1.0b/web/index.html	(revision 1251)
@@ -47,5 +47,5 @@
 
 <h2>Current Release</h2>
-ASAP latest stable version 2.0 was released on April, 27<sup>th</sup> 2006. It can be obtained in the <a href="#download">Download</a> section.
+<b class="asap">ASAP</b> latest stable version 2.1 was released on September, 11<sup>th</sup> 2006. It can be obtained in the <a href="#download">Download</a> section.
 
 <h2>Screenshots</h2>
@@ -69,10 +69,10 @@
 <h2>Defects and enhancement requests</h2>
 Bugs and enhancement requests can be submitted online, via the <a href="http://sourcecode.atnf.csiro.au/cgi-bin/trac_asap.cgi/newticket">
-ASAP project tracking page</a>. Please also check if the defect has already been submitted under
+<b class="asap">ASAP</b> project tracking page</a>. Please also check if the defect has already been submitted under
 <a href="http://sourcecode.atnf.csiro.au/cgi-bin/trac_asap.cgi/report/1">current tickets</a>.
 
 
 <h2>Documentation</h2>
-ASAP has a user guide for general use and telescope specific examples,
+<b class="asap">ASAP</b> has a user guide for general use and telescope specific examples,
 and a reference manual for people who want to write scripts to reduce
 and analyse their data.
@@ -88,5 +88,5 @@
 <p>
 The <a href="http://sourcecode.atnf.csiro.au/cgi-bin/trac_asap.cgi">Trac page</a>
-for ASAP also contains information about building from source and some more detailed information. It also shows information regarding release dates and milestones.
+for <b class="asap">ASAP</b> also contains information about building from source and some more detailed information. It also shows information regarding release dates and milestones.
 
 
@@ -110,11 +110,11 @@
 
 <a name="download"><h2>Download</h2></a>
-ASAP binaries are available in the <a href="http://www.atnf.csiro.au/pub/software/asap/current">ATNF ftp area</a>
+<b class="asap">ASAP</b> binaries are available in the <a href="http://www.atnf.csiro.au/pub/software/asap/current">ATNF ftp area</a>
 Please also consult the <a href="http://sourcecode.atnf.csiro.au/cgi-bin/trac_asap.cgi/wiki">wiki</a>
 <ul>
   <li> We provide binaries for debian, fedora and OSX based systems. If yours isn't there
-  send a request ging details about your flavour of linux.
+  send a request giving details about your flavour of linux.
   </li>
-  <li>ASAP source code is avavilble through our subversion repository
+  <li><b class="asap">ASAP</b> source code is available through our subversion repository
     <pre>
         svn co http://sourcecode.atnf.csiro.au/repos/asap/branches/Release2.1 asap2.1
@@ -125,5 +125,5 @@
 
 <h2>Important</h2>
-ASAP is 0-based, i.e. all ranges (vectors) go from
+<b class="asap">ASAP</b> is 0-based, i.e. all ranges (vectors) go from
 0..n-1, if n is the number of elements.
 <br>