Index: tags/Release2.1.1b/python/__init__.py
===================================================================
--- tags/Release2.1.1b/python/__init__.py	(revision 1276)
+++ tags/Release2.1.1b/python/__init__.py	(revision 1283)
@@ -253,4 +253,6 @@
     rcParams.update(rcParamsDefault)
 
+def _n_bools(n, val):
+    return [ val for i in xrange(n) ] 
 
 def _is_sequence_or_number(param, ptype=int):
@@ -301,5 +303,5 @@
     if not os.path.isdir(path):
         return None
-    valid = "rpf sdf sdfits mbf asap".split()
+    valid = "rpf rpf.1 rpf.2 sdf sdfits mbf asap".split()
     if not suffix in valid:
         return None
@@ -325,11 +327,14 @@
     return
 
-try:
-    import numpy.core as NUM
-except ImportError:
-    try:
-        import numarray as NUM
-    except ImportError:
-        raise ImportError("You need to have numpy or numarray installed")
+def mask_and(a, b):
+    assert(len(a)==len(b))
+    return [ a[i] & b[i] for i in xrange(len(a)) ]
+
+def mask_or(a, b):
+    assert(len(a)==len(b))
+    return [ a[i] | b[i] for i in xrange(len(a)) ]
+
+def mask_not(a):
+    return [ not i for i in a ]
 
 from asapfitter import fitter
@@ -342,15 +347,14 @@
 from linecatalog import linecatalog
 
-mask_and = NUM.logical_and
-mask_or = NUM.logical_or
-mask_not = NUM.logical_not
-
 if rcParams['useplotter']:
-    from  asapplotter import asapplotter
-    gui = os.environ.has_key('DISPLAY') and rcParams['plotter.gui']
-    if gui:
-        import pylab as xyplotter
-    plotter = asapplotter(gui)
-    del gui
+    try:
+	from  asapplotter import asapplotter
+	gui = os.environ.has_key('DISPLAY') and rcParams['plotter.gui']
+	if gui:
+	    import pylab as xyplotter
+	    plotter = asapplotter(gui)
+	    del gui
+    except ImportError:
+	print "Matplotlib not installed. No plotting available"
 
 __date__ = '$Date$'.split()[1]
Index: tags/Release2.1.1b/python/asapfitter.py
===================================================================
--- tags/Release2.1.1b/python/asapfitter.py	(revision 1276)
+++ tags/Release2.1.1b/python/asapfitter.py	(revision 1283)
@@ -2,5 +2,5 @@
 from asap import rcParams
 from asap import print_log
-from asap import NUM
+from asap import _n_bools
 
 class fitter:
@@ -42,5 +42,5 @@
         self.y = ydat
         if mask == None:
-            self.mask = NUM.ones(len(xdat))
+            self.mask = _n_bools(len(xdat), True)
         else:
             self.mask = mask
@@ -65,5 +65,5 @@
         self.mask = None
         if mask is None:
-            self.mask = NUM.ones(self.data.nchan())
+            self.mask = _n_bools(self.data.nchan(), True)
         else:
             self.mask = mask
@@ -215,6 +215,6 @@
         if self.fitfunc == "gauss" and component is not None:
             if not self.fitted and sum(self.fitter.getparameters()) == 0:
-                pars = list(NUM.zeros(len(self.components)*3))
-                fxd = list(NUM.zeros(len(pars)))
+                pars = _n_bools(len(self.components)*3, False)
+                fxd = _n_bools(len(pars), False)
             else:
                 pars = list(self.fitter.getparameters())
Index: tags/Release2.1.1b/python/asapplotter.py
===================================================================
--- tags/Release2.1.1b/python/asapplotter.py	(revision 1276)
+++ tags/Release2.1.1b/python/asapplotter.py	(revision 1283)
@@ -1,4 +1,3 @@
 from asap import rcParams, print_log, selector
-from asap import NUM
 import matplotlib.axes
 import sre
Index: tags/Release2.1.1b/python/scantable.py
===================================================================
--- tags/Release2.1.1b/python/scantable.py	(revision 1276)
+++ tags/Release2.1.1b/python/scantable.py	(revision 1283)
@@ -4,6 +4,6 @@
 from asap import asaplog
 from asap import selector
-from asap import NUM
 from asap import linecatalog
+from asap import _n_bools, mask_not, mask_and, mask_or
 
 class scantable(Scantable):
@@ -721,5 +721,5 @@
             asaplog.push(msg)
         n = self.nchan()
-        msk = NUM.zeros(n)
+        msk = _n_bools(n, False)
         # test if args is a 'list' or a 'normal *args - UGLY!!!
 
@@ -731,8 +731,8 @@
             for i in range(n):
                 if data[i] >= window[0] and data[i] <= window[1]:
-                    msk[i] = 1
+                    msk[i] = True
         if kwargs.has_key('invert'):
             if kwargs.get('invert'):
-                msk = NUM.logical_not(msk)
+                msk = mask_not(msk)
         print_log()
         return msk
@@ -1202,5 +1202,5 @@
         varlist = vars()
         if mask is None:
-            mask = list(NUM.ones(self.nchan(-1)))
+            mask = [True for i in xrange(self.nchan(-1))]
         from asap.asapfitter import fitter
         try: